<template>
  <component :is="label.length ? 'label' : 'div'" :for="id" class="relative block">
    <span v-if="label.length" class="mb-2">{{ label }}:</span>
    <input
      ref="innerInput"
      v-bind="$attrs"
      v-model="innerValue"
      :id="id"
      class="w-full appearance-none rounded border px-4 py-2 leading-tight text-ec-dark-100 shadow focus:shadow-ec-primary focus:outline-none"
    />
    <small v-if="helperText.length">{{ helperText }}</small>
  </component>
</template>

<script setup lang="ts">
import { ref, watch } from 'vue';

const innerInput = ref<HTMLInputElement | null>(null);

defineExpose({
  innerInput,
});

const props = defineProps({
  id: {
    type: String,
    required: true,
  },
  label: {
    type: String,
    default: '',
  },
  value: {
    type: String,
    default: '',
  },
  helperText: {
    type: String,
    default: '',
  },
});

const emit = defineEmits(['update:modelValue']);

const innerValue = ref(props.value);

watch(innerValue, (newValue) => {
  emit('update:modelValue', newValue);
});
</script>
